Last Comment Bug 771569 - startup crash in nsNSSComponent::ConfigureInternalPKCS11Token @ ld-2.16.so@0xb8a3 mainly on ArchLinux
: startup crash in nsNSSComponent::ConfigureInternalPKCS11Token @ ld-2.16.so@0x...
Status: RESOLVED FIXED
[startupcrash]
: crash, topcrash
Product: Core
Classification: Components
Component: Build Config (show other bugs)
: 14 Branch
: x86_64 Linux
: -- critical (vote)
: mozilla16
Assigned To: Mike Hommey [:glandium]
:
:
Mentors:
: 770819 (view as bug list)
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-06 10:05 PDT by Scoobidiver (away)
Modified: 2012-07-10 16:00 PDT (History)
7 users (show)
See Also:
Crash Signature:
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
wontfix
+
verified
+
verified
14+
verified


Attachments
glibc fix (622 bytes, patch)
2012-07-09 01:46 PDT, Mike Hommey [:glandium]
no flags Details | Diff | Splinter Review
Move elfhack sections before .rel{,a}.dyn to work around glibc 2.16 bug (2.26 KB, patch)
2012-07-09 03:40 PDT, Mike Hommey [:glandium]
nfroyd: review+
Details | Diff | Splinter Review
Move elfhack sections before .rel{,a}.dyn to work around glibc 2.16 bug. (2.73 KB, patch)
2012-07-09 08:11 PDT, Mike Hommey [:glandium]
nfroyd: review+
akeybl: approval‑mozilla‑aurora+
akeybl: approval‑mozilla‑beta+
akeybl: approval‑mozilla‑esr10+
Details | Diff | Splinter Review

Description Scoobidiver (away) 2012-07-06 10:05:07 PDT
It's #1 top crasher in 14.0b10 and 15.0a2 on Linux.
It first appeared on these builds on July 4 at 11H UTC.

Signature 	ld-2.16.so@0xb8a3 More Reports Search
UUID	4930288d-ab0e-4e10-af75-c73bb2120706
Date Processed	2012-07-06 15:50:13
Uptime	1
Last Crash	4.8 hours before submission
Install Age	1 seconds since version was first installed.
Install Time	2012-07-06 15:49:32
Product	Firefox
Version	15.0a2
Build ID	20120706042008
Release Channel	aurora
OS	Linux
OS Version	0.0.0 Linux 3.4.4-2-ARCH #1 SMP PREEMPT Sun Jun 24 18:59:47 CEST 2012 x86_64
Build Architecture	amd64
Build Architecture Info	family 15 model 12 stepping 0
Crash Reason	SIGSEGV
Crash Address	0x7fbb1380f1f8
Processor Notes 	WARNING: JSON file missing Add-ons
EMCheckCompatibility	False

Frame 	Module 	Signature 	Source
0 	ld-2.16.so 	ld-2.16.so@0xb8a3 	
1 	libc-2.16.so 	libc-2.16.so@0x6ca7 	
2 	libnspr4.so 	pr_LoadLibraryByPathname 	nsprpub/pr/src/linking/prlink.c:803
3 	ld-2.16.so 	ld-2.16.so@0x12a07 	
4 	ld-2.16.so 	ld-2.16.so@0xe785 	
5 	ld-2.16.so 	ld-2.16.so@0x1281f 	
6 	libnspr4.so 	PR_Unlock 	nsprpub/pr/src/pthreads/ptsynch.c:208
7 	libxul.so 	nsNSSComponent::ConfigureInternalPKCS11Token 	security/manager/ssl/src/nsNSSComponent.cpp:910
8 	libxul.so 	nsNSSComponent::InitializeNSS 	security/manager/ssl/src/nsNSSComponent.cpp:1747
9 	libxul.so 	nsNSSComponent::Init 	security/manager/ssl/src/nsNSSComponent.cpp:1984
10 	libxul.so 	nsNSSComponentConstructor 	security/manager/ssl/src/nsNSSModule.cpp:175
11 	libxul.so 	nsComponentManagerImpl::CreateInstanceByContractID 	xpcom/components/nsComponentManager.cpp:1032
12 	libxul.so 	nsComponentManagerImpl::GetServiceByContractID 	xpcom/components/nsComponentManager.cpp:1434
13 	libxul.so 	nsGetServiceByContractID::operator 	obj-firefox/xpcom/build/nsComponentManagerUtils.cpp:62
14 	libxul.so 	nsCOMPtr_base::assign_from_gs_contractid 	obj-firefox/xpcom/build/nsCOMPtr.cpp:99
15 	libxul.so 	EnsureNSSInitialized 	security/manager/ssl/src/nsNSSComponent.cpp:303
16 	libxul.so 	nsRandomGeneratorConstructor 	security/manager/ssl/src/nsNSSModule.cpp:218
17 	libxul.so 	nsComponentManagerImpl::CreateInstance 	xpcom/components/nsComponentManager.cpp:945
18 	libxul.so 	nsJSCID::CreateInstance 	js/xpconnect/src/XPCJSID.cpp:736
19 	libxul.so 	NS_InvokeByIndex_P 	xptcinvoke_x86_64_unix.cpp:163
20 	libxul.so 	XPCWrappedNative::CallMethod 	js/xpconnect/src/XPCWrappedNative.cpp:3107
21 	libxul.so 	XPC_WN_CallMethod 	js/xpconnect/src/XPCWrappedNativeJSOps.cpp:1500
22 	libxul.so 	js::InvokeKernel 	js/src/jscntxtinlines.h:395
...

More reports at:
https://crash-stats.mozilla.com/report/list?signature=ld-2.16.so%400xb8a3
Comment 1 Frederic Bezies 2012-07-09 01:08:27 PDT
Also using archlinux here. Glibc 2.16 upgrade is guilty. See my - duplicate ? - bug #770819.

http://www.archlinux.org/packages/core/x86_64/glibc/ => glibc 2.16 went into core (stable repository) on 4 or 5 july.
Comment 2 Frederic Bezies 2012-07-09 01:09:43 PDT
Another crash report, using latest official aurora  build : https://crash-stats.mozilla.com/report/index/2b575399-c677-4936-bd4f-443802120709
Comment 3 Mike Hommey [:glandium] 2012-07-09 01:31:29 PDT
*** Bug 770819 has been marked as a duplicate of this bug. ***
Comment 4 Mike Hommey [:glandium] 2012-07-09 01:32:24 PDT
This is due to a glibc bug that breaks elfhack. :(
Comment 5 Mike Hommey [:glandium] 2012-07-09 01:46:42 PDT
Created attachment 640155 [details] [diff] [review]
glibc fix

For the record, this fixes the glibc bug. I'll file a glibc bug.
Comment 6 Mike Hommey [:glandium] 2012-07-09 03:40:50 PDT
Created attachment 640177 [details] [diff] [review]
Move elfhack sections before .rel{,a}.dyn to work around glibc 2.16 bug
Comment 7 Nathan Froyd [:froydnj] 2012-07-09 06:34:08 PDT
Comment on attachment 640177 [details] [diff] [review]
Move elfhack sections before .rel{,a}.dyn to work around glibc 2.16 bug

Works for me.
Comment 9 Mike Hommey [:glandium] 2012-07-09 08:11:16 PDT
Created attachment 640224 [details] [diff] [review]
Move elfhack sections before .rel{,a}.dyn to work around glibc 2.16 bug.
Comment 11 Mike Hommey [:glandium] 2012-07-09 10:20:30 PDT
Comment on attachment 640224 [details] [diff] [review]
Move elfhack sections before .rel{,a}.dyn to work around glibc 2.16 bug.

[Approval Request Comment]
If this is not a sec:{high,crit} bug, please state case for ESR consideration:
User impact if declined: Startup crash on Linux systems with glibc 2.16 (latest glibc release, known to be used on current arch linux).
Fix Landed on Version: Currently on m-i only.
Risk to taking this patch (and alternatives if risky): The patch doesn't intrinsically modify how elfhack works, it only moves the insertion point it uses. This had an impact when landing the first time because the check to know whether to actually elfhack or not became wrong because of the insertion point change, and this was fixed in the second landing. With the build not being red, it's pretty low risk.
String or UUID changes made by this patch: None
Comment 12 Alex Keybl [:akeybl] 2012-07-09 14:41:54 PDT
Comment on attachment 640224 [details] [diff] [review]
Move elfhack sections before .rel{,a}.dyn to work around glibc 2.16 bug.

[Triage Comment]
Low risk startup topcrash fix, and we should know if the signature swaps in the beta going to build today.

Please land ASAP, we're going to build in a matter of hours. Thanks!
Comment 14 Ryan VanderMeulen [:RyanVM] 2012-07-09 18:04:12 PDT
https://hg.mozilla.org/mozilla-central/rev/c0f7c33713b3
Comment 15 Anthony Hughes (:ashughes) [GFX][QA][Mentor] 2012-07-10 09:39:09 PDT
Frederic, would you mind checking if this is fixed for you now with the latest Nightly and 10.0.6esrpre builds?
Comment 16 Mike Hommey [:glandium] 2012-07-10 09:51:52 PDT
Nightlies were not affected because they have --enable-profiling, and that disables elfhack. M-C debug builds were affected, but we don't have nightlies for that, so it would be best to test beta or aurora, and esr.
Comment 17 Frederic Bezies 2012-07-10 11:02:21 PDT
(In reply to Anthony Hughes, Mozilla QA (irc: ashughes) from comment #15)
> Frederic, would you mind checking if this is fixed for you now with the
> latest Nightly and 10.0.6esrpre builds?

I'm not at home right now, but I will test and report asap, at least for 10.0.6 esr pre build.
Comment 18 Frederic Bezies 2012-07-10 15:12:20 PDT
(In reply to Anthony Hughes, Mozilla QA (irc: ashughes) from comment #15)
> Frederic, would you mind checking if this is fixed for you now with the
> latest Nightly and 10.0.6esrpre builds?

Some results :

10.0.6 esr pre : revision 2ffb11d8b2f8 => OK
aurora : revision 23c1df05027f => OK
beta : revision 8b97fc666642 => OK

Hope it helps ;)
Comment 19 Anthony Hughes (:ashughes) [GFX][QA][Mentor] 2012-07-10 16:00:30 PDT
Thanks Frederic, calling this verified.

Note You need to log in before you can comment on or make changes to this bug.